﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Float {
  using Common;
  using Data;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class FloatConstantErcValue : ConstantsWeightedErcValue<double, DoubleArray> {

    public FloatConstantErcValue() : this(false, 1d) { }

    public FloatConstantErcValue(params double[] constants) : this(true, 1d, constants) { }

    public FloatConstantErcValue(bool isEnabled, double weight = 1d, params double[] constants)
      : base(isEnabled, new DoubleArray(constants), weight) {
      Name = "Float constants";
    }

    [StorableConstructor]
    public FloatConstantErcValue(bool deserializing) : base(deserializing) { }

    public FloatConstantErcValue(FloatConstantErcValue origin, Cloner cloner) : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new FloatConstantErcValue(this, cloner);
    }
  }
}
